Index: contrib/conf/ia32-qe.sh
===================================================================
--- contrib/conf/ia32-qe.sh	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ contrib/conf/ia32-qe.sh	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -8,3 +8,3 @@
 fi
 
-qemu -m 32 -hda "$DISK_IMG" -cdrom image.iso -boot d
+qemu $@ -m 32 -hda "$DISK_IMG" -cdrom image.iso -boot d
Index: contrib/conf/ppc32-qe.sh
===================================================================
--- contrib/conf/ppc32-qe.sh	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ contrib/conf/ppc32-qe.sh	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -1,3 +1,3 @@
 #!/bin/sh
 
-qemu-system-ppc -M mac99 -boot d -cdrom image.iso
+qemu-system-ppc $@ -M g3beige -boot d -cdrom image.iso
Index: contrib/tools/font/bdf2c.pl
===================================================================
--- contrib/tools/font/bdf2c.pl	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
+++ contrib/tools/font/bdf2c.pl	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -0,0 +1,164 @@
+#!/usr/bin/perl -w
+
+#
+# Copyright (c) 2000 Dmitry Bolkhovityanov
+# Copyright (c) 2009 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+use strict;
+
+my $skip;
+
+my $width;
+my $height;
+my $offset_x;
+my $offset_y;
+
+my $gwidth;
+my $gheight;
+my $goffset_x;
+my $goffset_y;
+
+my $index;
+my @glyphs;
+my @chars;
+
+open(BDF, "u_vga16.bdf") or die("Unable to open source font\n");
+
+READHEADER: while (<BDF>) {
+	/^FONTBOUNDINGBOX\s/ and do {
+		($skip, $width, $height, $offset_x, $offset_y) = (split);
+		
+		die("Font width is not 8px\n") if ($width != 8);
+		die("Font height is not 16px\n") if ($height != 16);
+	};
+	/^CHARS\s/ && last READHEADER;
+}
+
+READCHARS: while (<BDF>) {
+	/^ENCODING\s+([0-9]+)\s*$/ && do {
+		$index = $1;
+	};
+	/^BBX\s/ && do {
+		($skip, $gwidth, $gheight, $goffset_x, $goffset_y) = (split);
+	};
+	/^BITMAP/ && do {
+		my @glyph = ();
+		my $y;
+		
+		# Add empty lines at top
+		my $empties = $height + $offset_y - $goffset_y - $gheight;
+		
+		for ($y = 0; $y < $empties; $y++) {
+			$glyph[$y] = 0;
+		}
+		
+		# Scan the hex bitmap
+		for ($y = $empties; $y < $empties + $gheight; $y++) {
+			$_ = <BDF>;
+			$glyph[$y] = hex(substr($_, 0, 2)) >> $goffset_x;
+		}
+		
+		# Add empty lines at bottom
+		my $fill = $height - $gheight - $empties;
+		for ($y = $empties + $gheight; $y < $empties + $gheight + $fill; $y++) {
+			$glyph[$y] = 0;
+		}
+		
+		if ($index != 0) {
+			$glyphs[$index] = (\@glyph);
+			push(@chars, $index);
+		}
+	};
+	/^ENDFONT/ && last READCHARS;
+}
+
+close(BDF);
+
+@chars = sort { $a <=> $b } (@chars);
+
+print "#define FONT_GLYPHS     " . (@chars + 1). "\n";
+print "#define FONT_SCANLINES  " . $height . "\n";
+
+print "\n";
+print "uint16_t fb_font_glyph(const wchar_t ch)\n";
+print "{\n";
+print "\tif (ch == 0x0000)\n";
+print "\t\treturn 0;\n\n";
+
+my $pos = 0;
+my $start = -1;
+my $start_pos = 0;
+my $prev = 0;
+for $index (@chars) {
+	if ($prev + 1 < $index) {
+		if ($start != -1) {
+			if ($start == $prev) {
+				printf "\tif (ch == 0x%.4x)\n", $start;
+				print "\t\treturn " . $start_pos . ";\n";
+			} else {
+				printf "\tif ((ch >= 0x%.4x) && (ch <= 0x%.4x))\n", $start, $prev;
+				print "\t\treturn (ch - " . ($start - $start_pos) . ");\n";
+			}
+			
+			print "\t\n";
+		}
+		
+		$start = $index;
+		$start_pos = $pos;
+	}
+	
+	$pos++;
+	$prev = $index;
+}
+
+print "\treturn " . @chars . ";\n";
+print "}\n";
+
+print "\n";
+print "uint8_t fb_font[FONT_GLYPHS][FONT_SCANLINES] = {";
+
+for $index (@chars) {
+	print "\n\t{";
+	
+	my $y;
+	for ($y = 0; $y < $height; $y++) {
+		print ", " if ($y > 0);
+		printf "0x%.2x", $glyphs[$index]->[$y];
+	}
+	
+	print "},";
+}
+
+print "\n\t\n\t/* Special glyph for unknown character */\n\t{";
+my $y;
+for ($y = 0; $y < $height; $y++) {
+	print ", " if ($y > 0);
+	printf "0x%.2x", $glyphs[63]->[$y];
+}
+
+print "}\n};\n";
Index: contrib/tools/gen_vga323.c
===================================================================
--- contrib/tools/gen_vga323.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ contrib/tools/gen_vga323.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -33,5 +33,6 @@
 #define BLUE(i)   ((i) & ((1 << 3) - 1))
 
-int main(int argc, char *argv[]) {
+int main(int argc, char *argv[])
+{
 	unsigned int i;
 	
Index: defaults/mips64/output
===================================================================
--- defaults/mips64/output	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
+++ defaults/mips64/output	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -0,0 +1,1 @@
+image.boot
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/Makefile	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -59,4 +59,5 @@
 REAL_MAP = generic/src/debug/real_map
 
+ABI_INCLUDE = generic/include/abi
 ARCH_INCLUDE = generic/include/arch
 GENARCH_INCLUDE = generic/include/genarch
@@ -75,5 +76,5 @@
 
 clean:
-	rm -f $(DEPEND) $(DEPEND_PREV) $(RAW) $(BIN) $(MAP) $(JOB) $(MAP_PREV) $(DISASM) $(DUMP) $(REAL_MAP).* $(ARCH_INCLUDE) $(GENARCH_INCLUDE) arch/*/_link.ld arch/*/include/common.h
+	rm -f $(DEPEND) $(DEPEND_PREV) $(RAW) $(BIN) $(MAP) $(JOB) $(MAP_PREV) $(DISASM) $(DUMP) $(REAL_MAP).* $(ABI_INCLUDE) $(ARCH_INCLUDE) $(GENARCH_INCLUDE) arch/*/_link.ld arch/*/include/common.h
 	find generic/src/ arch/*/src/ genarch/src/ test/ -name '*.o' -follow -exec rm \{\} \;
 
@@ -94,5 +95,5 @@
 	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
 	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
+	-std=gnu99 -Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
 	-Werror-implicit-function-declaration -Wwrite-strings \
 	-pipe
@@ -134,5 +135,5 @@
 #
 AFLAGS =
-LFLAGS = -N -T $(LINK) -M
+LFLAGS = -n -T $(LINK) -M
 
 #
@@ -226,7 +227,7 @@
 	generic/src/proc/task.c \
 	generic/src/proc/the.c \
-	generic/src/proc/tasklet.c \
 	generic/src/syscall/syscall.c \
 	generic/src/syscall/copy.c \
+	generic/src/mm/reserve.c \
 	generic/src/mm/buddy.c \
 	generic/src/mm/frame.c \
@@ -240,4 +241,5 @@
 	generic/src/lib/func.c \
 	generic/src/lib/memstr.c \
+	generic/src/lib/memfnc.c \
 	generic/src/lib/sort.c \
 	generic/src/lib/str.c \
@@ -328,43 +330,4 @@
 	endif
 	
-	ifeq ($(CONFIG_FPU),y)
-		ifeq ($(KARCH),ia32)
-			TEST_FPU1 = y
-			TEST_SSE1 = y
-			GENERIC_SOURCES += test/fpu/fpu1_x86.c
-		endif
-		
-		ifeq ($(KARCH),amd64)
-			TEST_FPU1 = y
-			TEST_SSE1 = y
-			GENERIC_SOURCES += test/fpu/fpu1_x86.c
-		endif
-		
-		ifeq ($(KARCH),ia64)
-			TEST_FPU1 = y
-			GENERIC_SOURCES += test/fpu/fpu1_ia64.c
-		endif
-		
-		ifeq ($(KARCH),mips32)
-			TEST_MIPS2 = y
-		endif
-	endif
-	
-	ifneq ($(TEST_FPU1),y)
-		GENERIC_SOURCES += test/fpu/fpu1_skip.c
-	endif
-	
-	ifeq ($(TEST_SSE1),y)
-		GENERIC_SOURCES += test/fpu/sse1.c
-	else
-		GENERIC_SOURCES += test/fpu/sse1_skip.c
-	endif
-	
-	ifeq ($(TEST_MIPS2),y)
-		GENERIC_SOURCES += test/fpu/mips2.c
-	else
-		GENERIC_SOURCES += test/fpu/mips2_skip.c
-	endif
-	
 endif
 
@@ -381,5 +344,4 @@
 		generic/src/main/kinit.c \
 		generic/src/proc/the.c \
-		generic/src/proc/tasklet.c \
 		generic/src/mm/frame.c \
 		generic/src/mm/page.c \
@@ -439,19 +401,4 @@
 	$(JOBFILE) $(JOB) $< $@ as asm $(DEFS) $(CFLAGS) $(EXTRA_FLAGS)
 endif
-
-#
-# The FPU tests are the only objects for which we allow the compiler to generate
-# FPU instructions.
-#
-
-test/fpu/%.o: test/fpu/%.c $(DEPEND)
-	$(CC) $(DEFS) $(CFLAGS) $(EXTRA_FLAGS) -c -o $@ $<
-ifeq ($(PRECHECK),y)
-	$(JOBFILE) $(JOB) $< $@ cc test $(DEFS) $(CFLAGS) $(EXTRA_FLAGS)
-endif
-
-#
-# Ordinary objects.
-#
 
 %.o: %.c $(DEPEND)
@@ -486,8 +433,11 @@
 	$(GENMAP) $(MAP_PREV) $(DUMP) $@
 
-$(DEPEND): $(ARCH_INCLUDE) $(GENARCH_INCLUDE) $(COMMON_HEADER_ARCH)
+$(DEPEND): $(ABI_INCLUDE) $(ARCH_INCLUDE) $(GENARCH_INCLUDE) $(COMMON_HEADER_ARCH)
 	makedepend -f - -- $(DEPEND_DEFS) $(CFLAGS) -- $(ARCH_SOURCES) $(GENARCH_SOURCES) $(GENERIC_SOURCES) > $@ 2> /dev/null
 	-[ -f $(DEPEND_PREV) ] && diff -q $(DEPEND_PREV) $@ && mv -f $(DEPEND_PREV) $@
 
+$(ABI_INCLUDE): ../abi/include/
+	ln -sfn ../../$< $@
+
 $(ARCH_INCLUDE): arch/$(KARCH)/include/
 	ln -sfn ../../$< $@
Index: kernel/arch/abs32le/include/istate.h
===================================================================
--- kernel/arch/abs32le/include/istate.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/abs32le/include/istate.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -36,15 +36,12 @@
 #define KERN_abs32le_ISTATE_H_
 
+#include <trace.h>
+
 #ifdef KERNEL
 
-#include <typedefs.h>
 #include <verify.h>
-#include <trace.h>
 
 #else /* KERNEL */
 
-#include <sys/types.h>
-
-#define NO_TRACE
 #define REQUIRES_EXTENT_MUTABLE(arg)
 #define WRITES(arg)
Index: kernel/arch/abs32le/include/mm/as.h
===================================================================
--- kernel/arch/abs32le/include/mm/as.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/abs32le/include/mm/as.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -43,6 +43,4 @@
 #define USER_ADDRESS_SPACE_END_ARCH      UINT32_C(0x7fffffff)
 
-#define USTACK_ADDRESS_ARCH  (USER_ADDRESS_SPACE_END_ARCH - (PAGE_SIZE - 1))
-
 typedef struct {
 } as_arch_t;
Index: kernel/arch/abs32le/include/mm/frame.h
===================================================================
--- kernel/arch/abs32le/include/mm/frame.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/abs32le/include/mm/frame.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -39,6 +39,4 @@
 #define FRAME_SIZE   (1 << FRAME_WIDTH)
 
-#ifdef KERNEL
-
 #include <typedefs.h>
 
@@ -46,6 +44,4 @@
 extern void physmem_print(void);
 
-#endif /* KERNEL */
-
 #endif
 
Index: kernel/arch/abs32le/include/mm/page.h
===================================================================
--- kernel/arch/abs32le/include/mm/page.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/abs32le/include/mm/page.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -41,6 +41,4 @@
 #define PAGE_WIDTH  FRAME_WIDTH
 #define PAGE_SIZE   FRAME_SIZE
-
-#ifdef KERNEL
 
 #define KA2PA(x)  (((uintptr_t) (x)) - UINT32_C(0x80000000))
@@ -178,6 +176,4 @@
 extern void page_fault(unsigned int, istate_t *);
 
-#endif /* KERNEL */
-
 #endif
 
Index: kernel/arch/abs32le/include/types.h
===================================================================
--- kernel/arch/abs32le/include/types.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/abs32le/include/types.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -40,4 +40,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 
 typedef uint32_t uintptr_t;
Index: kernel/arch/abs32le/src/userspace.c
===================================================================
--- kernel/arch/abs32le/src/userspace.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/abs32le/src/userspace.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -36,7 +36,6 @@
 #include <typedefs.h>
 #include <arch.h>
-#include <proc/uarg.h>
+#include <abi/proc/uarg.h>
 #include <mm/as.h>
-
 
 void userspace(uspace_arg_t *kernel_uarg)
Index: kernel/arch/amd64/Makefile.inc
===================================================================
--- kernel/arch/amd64/Makefile.inc	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/Makefile.inc	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -33,5 +33,24 @@
 
 FPU_NO_CFLAGS = -mno-sse -mno-sse2
-CMN1 = -m64 -mcmodel=large -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer
+
+#
+# FIXME:
+#
+# The -fno-optimize-sibling-calls should be removed as soon as a bug
+# in GCC concerning the "large" memory model and tail call optimization
+# is fixed.
+#
+# When GCC generates a code for tail call, instead of generating ..
+#
+#   jmp *fnc
+#
+# it generates an assembly code with an illegal immediate prefix:
+#
+#   jmp *$fnc
+#
+# See http://gcc.gnu.org/bugzilla/show_bug.cgi?id=48385 for reference.
+#
+
+CMN1 = -m64 -mcmodel=large -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer -fno-optimize-sibling-calls
 GCC_CFLAGS += $(CMN1)
 ICC_CFLAGS += $(CMN1)
Index: kernel/arch/amd64/_link.ld.in
===================================================================
--- kernel/arch/amd64/_link.ld.in	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/_link.ld.in	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -26,10 +26,10 @@
 	.mapped (PA2KA(BOOT_OFFSET)+SIZEOF(.unmapped)) : AT (SIZEOF(.unmapped)) {
 		ktext_start = .;
-		*(.text);
+		*(.text .text.*);
 		ktext_end = .;
 		
 		kdata_start = .;
-		*(.data);       /* initialized data */
-		*(.rodata*);    /* string literals */
+		*(.data);              /* initialized data */
+		*(.rodata .rodata.*);  /* string literals */
 		hardcoded_load_address = .;
 		QUAD(PA2KA(BOOT_OFFSET));
Index: kernel/arch/amd64/include/asm.h
===================================================================
--- kernel/arch/amd64/include/asm.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/include/asm.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -89,5 +89,5 @@
 NO_TRACE static inline uint8_t pio_read_8(ioport8_t *port)
 {
-	if (((void *)port) < IO_SPACE_BOUNDARY) {
+	if (port < (ioport8_t *) IO_SPACE_BOUNDARY) {
 		uint8_t val;
 		asm volatile (
@@ -112,5 +112,5 @@
 NO_TRACE static inline uint16_t pio_read_16(ioport16_t *port)
 {
-	if (((void *)port) < IO_SPACE_BOUNDARY) {
+	if (port < (ioport16_t *) IO_SPACE_BOUNDARY) {
 		uint16_t val;
 		asm volatile (
@@ -135,5 +135,5 @@
 NO_TRACE static inline uint32_t pio_read_32(ioport32_t *port)
 {
-	if (((void *)port) < IO_SPACE_BOUNDARY) {
+	if (port < (ioport32_t *) IO_SPACE_BOUNDARY) {
 		uint32_t val;
 		asm volatile (
@@ -158,5 +158,5 @@
 NO_TRACE static inline void pio_write_8(ioport8_t *port, uint8_t val)
 {
-	if (((void *)port) < IO_SPACE_BOUNDARY) {
+	if (port < (ioport8_t *) IO_SPACE_BOUNDARY) {
 		asm volatile (
 			"outb %b[val], %w[port]\n"
@@ -164,5 +164,5 @@
 		);	
 	} else {
-		*((uint8_t *) port) = val;
+		*port = val;
 	}
 }
@@ -178,5 +178,5 @@
 NO_TRACE static inline void pio_write_16(ioport16_t *port, uint16_t val)
 {
-	if (((void *)port) < IO_SPACE_BOUNDARY) {
+	if (port < (ioport16_t *) IO_SPACE_BOUNDARY) {
 		asm volatile (
 			"outw %w[val], %w[port]\n"
@@ -184,5 +184,5 @@
 		);
 	} else {
-		*((uint16_t *) port) = val;
+		*port = val;
 	}
 }
@@ -198,5 +198,5 @@
 NO_TRACE static inline void pio_write_32(ioport32_t *port, uint32_t val)
 {
-	if (((void *)port) < IO_SPACE_BOUNDARY) {
+	if (port < (ioport32_t *) IO_SPACE_BOUNDARY) {
 		asm volatile (
 			"outl %[val], %w[port]\n"
@@ -204,5 +204,5 @@
 		);
 	} else {
-		*((uint32_t *) port) = val;
+		*port = val;
 	}
 }
Index: kernel/arch/amd64/include/context.h
===================================================================
--- kernel/arch/amd64/include/context.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/include/context.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -36,6 +36,4 @@
 #define KERN_amd64_CONTEXT_H_
 
-#ifdef KERNEL
-
 #include <typedefs.h>
 
@@ -52,6 +50,4 @@
 		(c)->rbp = 0; \
 	} while (0)
-
-#endif /* KERNEL */
 
 /* We include only registers that must be preserved
Index: kernel/arch/amd64/include/istate.h
===================================================================
--- kernel/arch/amd64/include/istate.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/include/istate.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -36,16 +36,5 @@
 #define KERN_amd64_ISTATE_H_
 
-#ifdef KERNEL
-
-#include <typedefs.h>
 #include <trace.h>
-
-#else /* KERNEL */
-
-#include <sys/types.h>
-
-#define NO_TRACE
-
-#endif /* KERNEL */
 
 /** This is passed to interrupt handlers */
Index: kernel/arch/amd64/include/mm/as.h
===================================================================
--- kernel/arch/amd64/include/mm/as.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/include/mm/as.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -43,9 +43,6 @@
 #define KERNEL_ADDRESS_SPACE_START_ARCH  UINT64_C(0xffff800000000000)
 #define KERNEL_ADDRESS_SPACE_END_ARCH    UINT64_C(0xffffffffffffffff)
-
-#define USER_ADDRESS_SPACE_START_ARCH  UINT64_C(0x0000000000000000)
-#define USER_ADDRESS_SPACE_END_ARCH    UINT64_C(0x00007fffffffffff)
-
-#define USTACK_ADDRESS_ARCH  (USER_ADDRESS_SPACE_END_ARCH - (PAGE_SIZE - 1))
+#define USER_ADDRESS_SPACE_START_ARCH    UINT64_C(0x0000000000000000)
+#define USER_ADDRESS_SPACE_END_ARCH      UINT64_C(0x00007fffffffffff)
 
 #define as_constructor_arch(as, flags)  (as != as)
Index: kernel/arch/amd64/include/mm/frame.h
===================================================================
--- kernel/arch/amd64/include/mm/frame.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/include/mm/frame.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -39,5 +39,4 @@
 #define FRAME_SIZE   (1 << FRAME_WIDTH)
 
-#ifdef KERNEL
 #ifndef __ASM__
 
@@ -49,5 +48,4 @@
 
 #endif /* __ASM__ */
-#endif /* KERNEL */
 
 #endif
Index: kernel/arch/amd64/include/mm/page.h
===================================================================
--- kernel/arch/amd64/include/mm/page.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/include/mm/page.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -50,6 +50,4 @@
 #define PAGE_WIDTH  FRAME_WIDTH
 #define PAGE_SIZE   FRAME_SIZE
-
-#ifdef KERNEL
 
 #ifndef __ASM__
@@ -231,6 +229,4 @@
 #endif /* __ASM__ */
 
-#endif /* KERNEL */
-
 #endif
 
Index: kernel/arch/amd64/include/types.h
===================================================================
--- kernel/arch/amd64/include/types.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/include/types.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,4 +37,5 @@
 
 typedef uint64_t size_t;
+typedef int64_t ssize_t;
 
 typedef uint64_t uintptr_t;
Index: kernel/arch/amd64/src/asm.S
===================================================================
--- kernel/arch/amd64/src/asm.S	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/src/asm.S	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,7 +37,4 @@
 .global read_efer_flag
 .global set_efer_flag
-.global memsetb
-.global memsetw
-.global memcpy
 .global memcpy_from_uspace
 .global memcpy_to_uspace
@@ -46,12 +43,4 @@
 .global early_putchar
 
-/* Wrapper for generic memsetb */
-memsetb:
-	jmp _memsetb
-
-/* Wrapper for generic memsetw */
-memsetw:
-	jmp _memsetw
-
 #define MEMCPY_DST   %rdi
 #define MEMCPY_SRC   %rsi
@@ -74,5 +63,4 @@
  *
  */
-memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
Index: kernel/arch/amd64/src/interrupt.c
===================================================================
--- kernel/arch/amd64/src/interrupt.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/src/interrupt.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -66,28 +66,27 @@
 void istate_decode(istate_t *istate)
 {
-	printf("cs =%#0" PRIx64 "\trip=%p\t"
-	    "rfl=%#0" PRIx64 "\terr=%#0" PRIx64 "\n",
-	    istate->cs, (void *) istate->rip,
-	    istate->rflags, istate->error_word);
+	printf("cs =%0#18" PRIx64 "\trip=%0#18" PRIx64 "\t"
+	    "rfl=%0#18" PRIx64 "\terr=%0#18" PRIx64 "\n",
+	    istate->cs, istate->rip, istate->rflags, istate->error_word);
 	
 	if (istate_from_uspace(istate))
-		printf("ss =%#0" PRIx64 "\n", istate->ss);
-	
-	printf("rax=%#0" PRIx64 "\trbx=%#0" PRIx64 "\t"
-	    "rcx=%#0" PRIx64 "\trdx=%#0" PRIx64 "\n",
+		printf("ss =%0#18" PRIx64 "\n", istate->ss);
+	
+	printf("rax=%0#18" PRIx64 "\trbx=%0#18" PRIx64 "\t"
+	    "rcx=%0#18" PRIx64 "\trdx=%0#18" PRIx64 "\n",
 	    istate->rax, istate->rbx, istate->rcx, istate->rdx);
 	
-	printf("rsi=%p\trdi=%p\trbp=%p\trsp=%p\n",
-	    (void *) istate->rsi, (void *) istate->rdi,
-	    (void *) istate->rbp,
-	    istate_from_uspace(istate) ? ((void *) istate->rsp) :
-	    &istate->rsp);
-	
-	printf("r8 =%#0" PRIx64 "\tr9 =%#0" PRIx64 "\t"
-	    "r10=%#0" PRIx64 "\tr11=%#0" PRIx64 "\n",
+	printf("rsi=%0#18" PRIx64 "\trdi=%0#18" PRIx64 "\t"
+	    "rbp=%0#18" PRIx64 "\trsp=%0#18" PRIx64 "\n",
+	    istate->rsi, istate->rdi, istate->rbp,
+	    istate_from_uspace(istate) ? istate->rsp :
+	    (uintptr_t) &istate->rsp);
+	
+	printf("r8 =%0#18" PRIx64 "\tr9 =%0#18" PRIx64 "\t"
+	    "r10=%0#18" PRIx64 "\tr11=%0#18" PRIx64 "\n",
 	    istate->r8, istate->r9, istate->r10, istate->r11);
 	
-	printf("r12=%#0" PRIx64 "\tr13=%#0" PRIx64 "\t"
-	    "r14=%#0" PRIx64 "\tr15=%#0" PRIx64 "\n",
+	printf("r12=%0#18" PRIx64 "\tr13=%0#18" PRIx64 "\t"
+	    "r14=%0#18" PRIx64 "\tr15=%0#18" PRIx64 "\n",
 	    istate->r12, istate->r13, istate->r14, istate->r15);
 }
Index: kernel/arch/amd64/src/proc/scheduler.c
===================================================================
--- kernel/arch/amd64/src/proc/scheduler.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/src/proc/scheduler.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -56,5 +56,5 @@
 {
 	CPU->arch.tss->rsp0 =
-	    (uintptr_t) &THREAD->kstack[THREAD_STACK_SIZE];
+	    (uintptr_t) &THREAD->kstack[STACK_SIZE];
 	
 	/*
Index: kernel/arch/amd64/src/userspace.c
===================================================================
--- kernel/arch/amd64/src/userspace.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/amd64/src/userspace.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -38,7 +38,6 @@
 #include <typedefs.h>
 #include <arch.h>
-#include <proc/uarg.h>
+#include <abi/proc/uarg.h>
 #include <mm/as.h>
-
 
 /** Enter userspace
@@ -66,5 +65,5 @@
 		"iretq\n"
 		:: [udata_des] "i" (GDT_SELECTOR(UDATA_DES) | PL_USER),
-		   [stack_size] "r" (kernel_uarg->uspace_stack + THREAD_STACK_SIZE),
+		   [stack_size] "r" (kernel_uarg->uspace_stack + STACK_SIZE),
 		   [ipl] "r" (ipl),
 		   [utext_des] "i" (GDT_SELECTOR(UTEXT_DES) | PL_USER),
Index: kernel/arch/arm32/include/istate.h
===================================================================
--- kernel/arch/arm32/include/istate.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/arm32/include/istate.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -35,13 +35,15 @@
 #define KERN_arm32_ISTATE_H_
 
+#include <trace.h>
+
+#ifdef KERNEL
+
 #include <arch/regutils.h>
 
-#ifdef KERNEL
-#include <typedefs.h>
-#include <trace.h>
-#else
-#include <sys/types.h>
-#define NO_TRACE
-#endif
+#else /* KERNEL */
+
+#include <libarch/regutils.h>
+
+#endif /* KERNEL */
 
 /** Struct representing CPU state saved when an exception occurs. */
Index: kernel/arch/arm32/include/mm/as.h
===================================================================
--- kernel/arch/arm32/include/mm/as.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/arm32/include/mm/as.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,12 +37,10 @@
 #define KERN_arm32_AS_H_
 
-#define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH	0
+#define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  0
 
-#define KERNEL_ADDRESS_SPACE_START_ARCH     (unsigned long) 0x80000000
-#define KERNEL_ADDRESS_SPACE_END_ARCH       (unsigned long) 0xffffffff
-#define USER_ADDRESS_SPACE_START_ARCH       (unsigned long) 0x00000000
-#define USER_ADDRESS_SPACE_END_ARCH         (unsigned long) 0x7fffffff
-
-#define USTACK_ADDRESS_ARCH	(0x80000000 - PAGE_SIZE)
+#define KERNEL_ADDRESS_SPACE_START_ARCH  UINT32_C(0x80000000)
+#define KERNEL_ADDRESS_SPACE_END_ARCH    UINT32_C(0xffffffff)
+#define USER_ADDRESS_SPACE_START_ARCH    UINT32_C(0x00000000)
+#define USER_ADDRESS_SPACE_END_ARCH      UINT32_C(0x7fffffff)
 
 typedef struct {
Index: kernel/arch/arm32/include/mm/frame.h
===================================================================
--- kernel/arch/arm32/include/mm/frame.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/arm32/include/mm/frame.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -40,5 +40,4 @@
 #define FRAME_SIZE   (1 << FRAME_WIDTH)
 
-#ifdef KERNEL
 #ifndef __ASM__
 
@@ -69,5 +68,4 @@
 
 #endif /* __ASM__ */
-#endif /* KERNEL */
 
 #endif
Index: kernel/arch/arm32/include/mm/page.h
===================================================================
--- kernel/arch/arm32/include/mm/page.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/arm32/include/mm/page.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -52,6 +52,4 @@
 #	define PA2KA(x)	((x) + 0x80000000)
 #endif
-
-#ifdef KERNEL
 
 /* Number of entries in each level. */
@@ -320,6 +318,4 @@
 #endif /* __ASM__ */
 
-#endif /* KERNEL */
-
 #endif
 
Index: kernel/arch/arm32/include/regutils.h
===================================================================
--- kernel/arch/arm32/include/regutils.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/arm32/include/regutils.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -30,5 +30,5 @@
  * @{
  */
-/** 
+/**
  * @file
  * @brief Utilities for convenient manipulation with ARM registers.
@@ -38,52 +38,49 @@
 #define KERN_arm32_REGUTILS_H_
 
-#define STATUS_REG_IRQ_DISABLED_BIT (1 << 7)
-#define STATUS_REG_MODE_MASK        0x1f
+#define STATUS_REG_IRQ_DISABLED_BIT  (1 << 7)
+#define STATUS_REG_MODE_MASK         0x1f
 
-#define CP15_R1_HIGH_VECTORS_BIT    (1 << 13)
-
+#define CP15_R1_HIGH_VECTORS_BIT     (1 << 13)
 
 /* ARM Processor Operation Modes */
-#define USER_MODE         0x10
-#define FIQ_MODE          0x11
-#define	IRQ_MODE          0x12
-#define	SUPERVISOR_MODE   0x13
-#define	ABORT_MODE        0x17
-#define	UNDEFINED_MODE    0x1b
-#define	SYSTEM_MODE       0x1f
+#define USER_MODE        0x10
+#define FIQ_MODE         0x11
+#define IRQ_MODE         0x12
+#define SUPERVISOR_MODE  0x13
+#define ABORT_MODE       0x17
+#define UNDEFINED_MODE   0x1b
+#define SYSTEM_MODE      0x1f
 
 /* [CS]PRS manipulation macros */
-#define GEN_STATUS_READ(nm,reg) \
-static inline uint32_t nm## _status_reg_read(void) \
-{ \
-	uint32_t retval; \
-	asm volatile( \
-		"mrs %[retval], " #reg \
-		: [retval] "=r" (retval) \
-	); \
-	return retval; \
-}
+#define GEN_STATUS_READ(nm, reg) \
+	static inline uint32_t nm## _status_reg_read(void) \
+	{ \
+		uint32_t retval; \
+		\
+		asm volatile ( \
+			"mrs %[retval], " #reg \
+			: [retval] "=r" (retval) \
+		); \
+		\
+		return retval; \
+	}
 
-#define GEN_STATUS_WRITE(nm,reg,fieldname, field) \
-static inline void nm## _status_reg_ ##fieldname## _write(uint32_t value) \
-{ \
-	asm volatile( \
-		"msr " #reg "_" #field ", %[value]" \
-		:: [value] "r" (value) \
-	); \
-}
+#define GEN_STATUS_WRITE(nm, reg, fieldname, field) \
+	static inline void nm## _status_reg_ ##fieldname## _write(uint32_t value) \
+	{ \
+		asm volatile ( \
+			"msr " #reg "_" #field ", %[value]" \
+			:: [value] "r" (value) \
+		); \
+	}
 
+/** Return the value of CPSR (Current Program Status Register). */
+GEN_STATUS_READ(current, cpsr);
 
-/** Returns the value of CPSR (Current Program Status Register). */
-GEN_STATUS_READ(current, cpsr)
-
-
-/** Sets control bits of CPSR. */
+/** Set control bits of CPSR. */
 GEN_STATUS_WRITE(current, cpsr, control, c);
 
-
-/** Returns the value of SPSR (Saved Program Status Register). */
-GEN_STATUS_READ(saved, spsr)
-
+/** Return the value of SPSR (Saved Program Status Register). */
+GEN_STATUS_READ(saved, spsr);
 
 #endif
Index: kernel/arch/arm32/include/types.h
===================================================================
--- kernel/arch/arm32/include/types.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/arm32/include/types.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -44,4 +44,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 
 typedef uint32_t uintptr_t;
Index: kernel/arch/arm32/src/arm32.c
===================================================================
--- kernel/arch/arm32/src/arm32.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/arm32/src/arm32.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,5 +37,5 @@
 #include <config.h>
 #include <genarch/fb/fb.h>
-#include <genarch/fb/visuals.h>
+#include <abi/fb/visuals.h>
 #include <sysinfo/sysinfo.h>
 #include <console/console.h>
@@ -134,5 +134,5 @@
 	uint8_t *stck;
 	
-	stck = &THREAD->kstack[THREAD_STACK_SIZE - SP_DELTA];
+	stck = &THREAD->kstack[STACK_SIZE - SP_DELTA];
 	supervisor_sp = (uintptr_t) stck;
 }
Index: kernel/arch/arm32/src/asm.S
===================================================================
--- kernel/arch/arm32/src/asm.S	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/arm32/src/asm.S	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -29,7 +29,4 @@
 .text
 
-.global memsetb
-.global memsetw
-.global memcpy
 .global memcpy_from_uspace
 .global memcpy_to_uspace
@@ -38,11 +35,4 @@
 .global early_putchar
 
-memsetb:
-	b _memsetb
-
-memsetw:
-	b _memsetw
-
-memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
